<template>
    <div>
        <div id="pokedex">
            <h1>Retrouvez vos 151 pokemons favoris !</h1>
            Rechercher : 
            <input type="text" v-model="search" name="" id="">
            <div v-if="pokemons && filter.length === 0" id="pokemon-list">
                <Card v-for="pokemon in pokemons" :key="pokemon" :id="pokemon.id" :sprite="pokemon.sprite" :name="pokemon.name"/>
            </div>
            <div v-if="filter" id="pokemon-list">
                <Card v-for="pokemon in filter" :key="pokemon" :id="pokemon.id" :sprite="pokemon.sprite" :name="pokemon.name"/>
            </div>
        </div>
    </div>
</template>

<script>
import Card from '../components/Home/Card'
export default {
    components: {
        Card
    },
    data() {
        return {
            pokemons: [],
            search: '',
            filter: []
        }
    },
    watch: {
        search() {
            if (this.search.length > 0) {
                this.filter = this.pokemons.filter(pokemon => pokemon.name.startsWith(this.search))
            } else [
                this.filter = []
            ]
            console.log(this.filter)
        }
    },
    mounted() {
        fetch(process.env.VUE_APP_API_URL + 'pokemon?limit=151')
        .then((res) => {
            if(res.status === 200) {
                return res.json().then(data => {
                    data.results.forEach(pokemon => {
                        fetch(pokemon.url).then((res => {
                            res.json().then(pokemon => {
                                this.pokemons.push({
                                    name: pokemon.name,
                                    sprite: pokemon.sprites.front_default,
                                    id: pokemon.id
                                })
                            })
                        }))
                    });
                })
            }
        })
    } 
}
</script>

<style scoped>
    #pokedex {
        background-color: #EAF2EF;
        max-width: 1080px;
        width: 100%;
        height: 100%;
        color: black;
        padding: 1%;
        box-shadow: 1px 5px 36px -7px #000000
    }

    #pokemon-list {
        display: flex;
        flex-wrap: wrap;
        justify-content: space-around;
    }
</style>